from deliverance import middleware
from deliverance import security
import os
from paste import urlparser

def make_deliverance_middleware(app, global_conf, rule_uri):
    rule_getter = middleware.SubrequestRuleGetter(rule_uri)
    app = middleware.DeliveranceMiddleware(app, rule_getter)
    return security.SecurityContext.middleware(app,
        display_local_files=True, display_logging=True)

here = os.path.abspath(os.path.dirname(__file__))
static = urlparser.StaticURLParser(os.path.join(here, 'static'))

def make_static_serving_app(global_conf, document_root=""):
    def app(environ, start_response):
        environ['SCRIPT_NAME'] = ''
        path_info = environ.get('PATH_INFO', '')
        environ['PATH_INFO'] = document_root + environ['PATH_INFO']
        return static(environ, start_response)
    return app
